import inspect


def join_designators(a: str, b: str) -> str:
    return '_'[:len(a) and len(b) and a[-1].isdigit() and b[0].isdigit()].join((a, b))


def all_implementations(cls):
    all_subclasses = {}

    fifo = [(cls, True)]

    while len(fifo):
        is_abstract: bool
        current_implementation, is_abstract = fifo.pop()
        name: str = current_implementation.__name__

        if name in all_subclasses:
            continue

        if not is_abstract:
            all_subclasses[name] = current_implementation

        for next_implementation in current_implementation.__subclasses__():
            fifo.append((next_implementation, inspect.isabstract(next_implementation)))

    return list(all_subclasses.values())
