from abc import abstractmethod
from typing import TypeVar
from dataspree.inference.sensor.data.tof_camera import TofCamera, TofCameraData
from dataspree.inference.sensor.driver.camera_driver import CameraDriver

T = TypeVar('T', bound=TofCamera)


class TofCameraDriver(CameraDriver[T]):
    def __init__(self) -> None:
        CameraDriver.__init__(self)

        ...

    @abstractmethod
    def fetch_sensor_data(self, sensor: T, timeout: float = 0.0) -> TofCameraData:
        ...

    @abstractmethod
    def create_item(self, sensor: T, sensor_data: TofCameraData) -> None:
        ...
